package com.eii.tooltray;

public class DesktopIndicatorTest implements DesktopIndicatorListener
{
	static DesktopIndicatorTest listener;
	static int clicks = 4;
	static int quickImage;
	static int comicImage;
		
	static public void main( String args[] )
	{
		// Initialize JNI extension
		if( !DesktopIndicator.initialize() )
		{
			System.err.println( "Either you are not on Windows, or there is a problem with the DesktopIndicator library!" );
			return;
		}

		// Load quick image
		quickImage = DesktopIndicator.loadImage( "c:\\temp\\quick.ico" );
		if( quickImage == -1 )
		{
			System.err.println( "Could not load the image file \"quick.ico\"!" );
			return;
		}
		
		// Load comic image
		comicImage = DesktopIndicator.loadImage( "c:\\temp\\comic.ico" );
		if( comicImage == -1 )
		{
			System.err.println( "Could not load the image file \"comic.ico\"!" );
			return;
		}
		
		// Create the indicator
		DesktopIndicator indicator = new DesktopIndicator();
		listener = new DesktopIndicatorTest();
		indicator.addDesktopIndicatorListener( listener );

		int img = indicator.loadImageFromResource(101);
		indicator.update(comicImage, "Test case");
		indicator.hide();
		indicator.show();
		indicator.hide();
		indicator.show();
		indicator.hide();
		indicator.update(img, "Test case");
		indicator.hide();
		indicator.show();
		
		// Instructions
		System.err.println( "See the taskbar icon? Click it!" );
	
		// Wait for the bitter end
		try
		{
			synchronized( listener )
			{
				listener.wait(10000);
			}
		}
		catch( InterruptedException x )
		{
		}

		// Time to die		
		indicator.removeDesktopIndicatorListener( listener );
		indicator.hide();


		System.err.println( "Goodbye!" );
		System.exit( 0 );
	}
	public void onDesktopIndicatorClicked( DesktopIndicator source )
	{
		System.err.println( String.valueOf( clicks ) + " click(s) left..." );
		
		// Countdown to death
		clicks--;
		
		if( clicks % 2 == 1 )
		{
			// Comic!
			source.update( comicImage, "A message for you, sir!" );
		}
		else
		{
			// Quick!
			source.update( quickImage, "Quick! Click me!" );
		}
		
		if( clicks == 0 )
		{
			// The end is nigh
			synchronized( listener )
			{
				listener.notifyAll();
			}
		}
	}
}
